pub const GLYPH_STATIC_STR: [&str; 256] = [
    // Printable ASCII characters
    " ", "!", "'", "#", "$", "%", "&", "\"", "(", ")", "*", "+", ",", "-", ".", "/", "0", "1", "2",
    "3", "4", "5", "6", "7", "8", "9", ":", ";", "<", "=", ">", "?", "@", "A", "B", "C", "D", "E",
    "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X",
    "Y", "Z", "[", "\\", "]", "^", "_", "`", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k",
    "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "{", "|", "}", "~",
    // Box Drawing Characters
    "▀", "▁", "▂", "▃", "▄", "▅", "▆", "▇", "█", "▉", "▊", "▋", "▌", "▍", "▎", "▏", "▐", "░", "▒",
    "▓", "▔", "▕", "▖", "▗", "▘", "▙", "▚", "▛", "▜", "▝", "▞", "▟", "─", "━", "│", "┃", "┄", "┅",
    "┆", "┇", "┈", "┉", "┊", "┋", "┌", "┍", "┎", "┏", "┐", "┑", "┒", "┓", "└", "┕", "┖", "┗", "┘",
    "┙", "┚", "┛", "├", "┝", "┞", "┟", "┠", "┡", "┢", "┣", "┤", "┥", "┦", "┧", "┨", "┩", "┪", "┫",
    "┬", "┭", "┮", "┯", "┰", "┳", "┴", "┶", "┷", "┸", "┹", "┺", "┻", "┼", "┿", "╀", "╁", "╂", "╃",
    "╄", "╅", "╆", "╇", "╈", "╉", "╊", "╋", "╌", "╍", "╎", "╏", "═", "║", "╒", "╓", "╔", "╕", "╖",
    "↕", "‼", "♪", "♫", "☎", "☏", "☺", "☻", "★", "☆", "▲", "▼", "↑", "↓", "→", "←", "►", "◄", "╭",
    "╮", "╯", "╰", "╱", "╲", "╳", "╴", "╵", "╶", "╷", "╸", "╹", "╺", "•", "◘", "○", "◙",
    "╿", //chess set
    "♚", "♛", "♜", "♝", "♞", "♟", //cards set
    "♠", "♣", "♥", "♦", //
];
//⠁⠂⠃⠄⠅⠆⠇⠈⠉⠊⠋⠌⠍⠎⠏⠐⠑⠒⠓⠔⠕⠖⠗⠘⠙⠚⠛⠜⠝⠞⠟⠠⠡⠢⠣⠤⠥⠦⠧⠨⠩⠪⠫⠬⠭⠮⠯⠰⠱⠲⠳⠴⠵⠶⠷⠸⠹⠺⠻⠼⠽⠾⠿
pub const HALF_UPPER_BLOCK: usize = 95;
pub const HALF_LOWER_BLOCK: usize = 99;

fn find_glyph_indices(input: &str) -> Vec<Option<usize>> {
    input
        .chars()
        .map(|ch| {
            GLYPH_STATIC_STR
                .iter()
                .position(|&glyph| glyph == ch.to_string())
        })
        .collect()
}
